import { HighlightStyle, syntaxHighlighting, LRLanguage, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { tags, styleTags } from '@lezer/highlight';
import { LRParser } from '@lezer/lr';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!^QYQPOOOeQPO'#CcOOQO'#Ci'#CiOOQO'#Ce'#CeQYQPOOOOQO'#Cd'#CdOOQO,58},58}OpQPO,58}OOQO-E6c-E6cOOQO1G.i1G.i",
  stateData: "u~O[OSPOS~ORQOSQOUPO~ORTOSTOTUO~OTXO~O",
  goto: "p^PPPPPPP_cfPPPlTQOSRVPQSORWSTROS",
  nodeNames: "⚠ LineComment Program Identifier String MustacheEnd MustacheStart Mustache MustacheContent",
  maxTerm: 13,
  nodeProps: [
    ["openedBy", 5,"MustacheStart"],
    ["closedBy", 6,"MustacheEnd"],
    ["isolate", 7,""]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%a~R^XY}YZ}]^}pq}rs!`st#|}!O$e!Q![$e!]!^#|!c!}$e#R#S$e#T#o$e#o#p$y#q#r%U~!SS[~XY}YZ}]^}pq}~!cVOr!`rs!xs#O!`#O#P!}#P;'S!`;'S;=`#v<%lO!`~!}OS~~#QRO;'S!`;'S;=`#Z;=`O!`~#^WOr!`rs!xs#O!`#O#P!}#P;'S!`;'S;=`#v;=`<%l!`<%lO!`~#yP;=`<%l!`~$RSP~OY#|Z;'S#|;'S;=`$_<%lO#|~$bP;=`<%l#|~$jTR~}!O$e!Q![$e!c!}$e#R#S$e#T#o$e~$|P#o#p%P~%UOU~~%XP#q#r%[~%aOT~",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

/* The `const highlightStyle` declaration is defining a custom syntax highlighting style for a specific
language feature. In this case, it is defining how certain tokens or elements should be visually
styled in the syntax highlighting of a Mustache templating language. */
const highlightStyle = HighlightStyle.define([
    { tag: tags.bracket, class: 'mustache-bracket' },
    { tag: tags.variableName, class: 'mustache-variable' },
    { tag: tags.special(tags.content), class: 'mustache-content' },
]);
const mustacheHighlighting = syntaxHighlighting(highlightStyle);
const mustacheLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            foldNodeProp.add({
                Mustache: foldInside, // Allow Mustache blocks to fold
            }),
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                LineComment: tags.lineComment,
                MustacheStart: tags.bracket,
                MustacheEnd: tags.bracket,
                MustacheContent: tags.variableName,
                Mustache: tags.special(tags.content), // Highlight Mustache content specifically
            }),
        ],
    }),
});
function mustache() {
    return new LanguageSupport(mustacheLanguage, [mustacheHighlighting]);
}

export { mustache, mustacheLanguage };
